(* Q1 *)

(* a) Se lit: double de x vaut 2 fois x *)
let double x = 2*x
(* test double *)
let a = double 3;;
(* assert b ne fait rien si b est true, 
   et arrête le programme si b est false.
   Cette fonction permet donc d'écrire des tests *)
assert (a = 6);; 
let b = double (2 + double 6)
let c = double (-7);;
assert(b = 28 && c = -14)

(* b) Ces fonctions existent déjà dans OCaml:
elles s'appellent fst et snd *) 
let first (x, y) = x
let second (x, y) = y

(* Alternatives *)
let first p =
	let (x, y) = p in
	x

let second p =
	let (x, y) = p in 
	y
;;

let paire1 = ("toto", 3.15);;
assert (first paire1 = "toto");;

assert (second (true, 5) = 5);;

(* c) Ne pas oublier les +. pour float *) 
let somme3 (x,y,z) = 
   x +. y +. z 

(* d) *) 
let est_pair x = 
   x mod 2 = 0

(* e) *) 
let divise x y = 
   y mod x = 0


(* Q2 *)
(* fst et snd sont first et second de la Q1b *)

(* Q3 *)
(* divise 3 est une fonction, qui renvoie true
si son argument est multiple de 3, false sinon.
On pourrait donc l'appeler "est_divisible_par_3" *)
let est_divisible_par_3 = 
   divise 3
;;

assert (est_divisible_par_3 57);;
assert (not (est_divisible_par_3 40));;

(* Q4 *)

(* ajouteur doit prendre en entrée un entier k
   et renvoyer une fonction de type (int -> int). 
   Autrement dit, pour k entier, ajouteur k
   est une fonction prenant en entrée un entier x
   et renvoyant x+k. On peut donc définir 
   la fonction ajouteur ainsi:
*)

let ajouteur k x = x + k
(* On peut aussi l'écrire comme suit, c'est plus
   simple de comprendre ce que ça renvoie, mais
   c'est moins élégant, en OCaml on aura tendance
   à utiliser la première version. *)
let ajouteur_bis k = fun x -> x + k


(* Q5 *)
let composee f g x = f (g x)
let composee_bis f g = fun x -> f (g x) (* équivalent *)

(* test composee *)
let ajouter_3 = ajouteur 3
let ajouter_7 = ajouteur 7
let ajouter_10 = composee ajouter_3 ajouter_7;;
(* La composition de ajouter_3 et ajouter_7 est bien
   une fonction qui ajoute 10 à son entrée *)
let x = ajouter_10 63;;
assert (x = 73);;

